#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Volume.h"
#include "AkAcousticPortalState.h"
#include "AkAcousticPortal.generated.h"

class UAkPortalComponent;

UCLASS(Blueprintable)
class AKAUDIO_API AAkAcousticPortal : public AVolume
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UAkPortalComponent* Portal;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	AkAcousticPortalState InitialState;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	bool bRequiresStateMigration;

public:
	UFUNCTION(BlueprintPure)
	AkAcousticPortalState GetCurrentState() const;

	UFUNCTION(BlueprintCallable)
	void EnablePortal();

	UFUNCTION(BlueprintCallable)
	void DisablePortal();

public:
	AAkAcousticPortal();
};

FORCEINLINE uint32 GetTypeHash(const AAkAcousticPortal) { return 0; }
